
#ifndef __Mod_GScript_SysDef__
#define __Mod_GScript_SysDef__

#module "ModGS_SysDef"

	#deffunc gs_sysdef_init
		sdim str_temp, 512
		p = 0
		s = 0

		gsc_func "end", *GS_END
		gsc_func "stop", *GS_END
		gsc_func "wait", *GS_WAIT, GSMD_INT
		gsc_func "await", *GS_WAIT, GSMD_INT
		gsc_func "waitfor", *GS_WAITFOR, GSMD_INT, GSMD_INT
		
		gsc_func "if", *GS_IF, GSMD_INT
		gsc_func_rule "if", *GSCRIPT_FUNC_RULE_IF@ModGS_Compile

		gsc_func "else", *GS_ELSE
		gsc_func_rule "else", *GSCRIPT_FUNC_RULE_ELSE@ModGS_Compile

		gsc_func "repeat", *GS_REPEAT, GSMD_INT, GSMD_INT
		gsc_func_rule "repeat", *GSCRIPT_FUNC_RULE_REPEAT@ModGS_Compile

		gsc_func "loop", *GS_LOOP
		gsc_func_rule "loop", *GSCRIPT_FUNC_RULE_LOOP@ModGS_Compile

		gsc_func "break", *GS_BREAK
		gsc_func_rule "break", *GSCRIPT_FUNC_RULE_BREAK@ModGS_Compile

		gsc_func "continue", *GS_CONTINUE, GSMD_INT
		gsc_func_rule "continue", *GSCRIPT_FUNC_RULE_CONTINUE@ModGS_Compile

		gsc_func "goto", *GS_GOTO, GSMD_LABEL
		gsc_func "gosub", *GS_GOSUB, GSMD_LABEL

		gsc_func "exgoto", *GS_EXGOTO, GSMD_STR
		gsc_func_rule "exgoto", *GSCRIPT_FUNC_RULE_EXGOTO@ModGS_Compile

		gsc_func "exgosub", *GS_EXGOSUB, GSMD_STR
		gsc_func_rule "exgosub", *GSCRIPT_FUNC_RULE_EXGOSUB@ModGS_Compile

		gsc_func "return", *GS_RETURN, GSMD_VALUE

		gsc_func "dim", *GS_DIM, GSMD_VARIABLE, GSMD_INT, GSMD_INT, GSMD_INT, GSMD_INT
		gsc_func "ddim", *GS_DDIM, GSMD_VARIABLE, GSMD_INT, GSMD_INT, GSMD_INT, GSMD_INT
		gsc_func "sdim", *GS_SDIM, GSMD_VARIABLE, GSMD_INT, GSMD_INT, GSMD_INT, GSMD_INT, GSMD_INT
		gsc_func "ldim", *GS_LDIM, GSMD_VARIABLE, GSMD_INT, GSMD_INT, GSMD_INT, GSMD_INT
		gsc_func "dimtype", *GS_DIMTYPE, GSMD_VARIABLE, GSMD_INT, GSMD_INT, GSMD_INT, GSMD_INT, GSMD_INT

		gsc_func "createthread", *GS_CREATETHREAD, GSMD_LABEL
		gsc_func "deletethread", *GS_DELETETHREAD, GSMD_INT

		;gsc_func "test", *GS_TEST, GSMD_INT, GSMD_INT, GSMD_INT, GSMD_INT

		return

//	{߂̎
*GS_DIM
	if _gsc_i1 == 0 {
		gsc_error -1, "dim: cannot omit a variable."
		return
	}
	gs_variable_recreateid _gsc_p1, GSMD_VARIABLE_TYPE_INT, 4, _gsc_p2, _gsc_p3, _gsc_p4, _gsc_p5
	return
*GS_DDIM
	if _gsc_i1 == 0 {
		gsc_error -1, "ddim: cannot omit a variable."
		return
	}
	gs_variable_recreateid _gsc_p1, GSMD_VARIABLE_TYPE_DOUBLE, 8, _gsc_p2, _gsc_p3, _gsc_p4, _gsc_p5
	return
*GS_SDIM
	if _gsc_i1 == 0 {
		gsc_error -1, "sdim: cannot omit a variable."
		return
	}
	gs_variable_recreateid _gsc_p1, GSMD_VARIABLE_TYPE_STR, _gsc_p2, _gsc_p3, _gsc_p4, _gsc_p5, _gsc_p6
	return
*GS_LDIM
	if _gsc_i1 == 0 {
		gsc_error -1, "ldim: cannot omit a variable."
		return
	}
	gs_variable_recreateid _gsc_p1, GSMD_VARIABLE_TYPE_LABEL, 4, _gsc_p2, _gsc_p3, _gsc_p4, _gsc_p5
	return
*GS_DIMTYPE
	if _gsc_i1 == 0 {
		gsc_error -1, "dimtype: cannot omit a variable."
		return
	}
	if _gsc_p2 == 1 : gs_variable_recreateid _gsc_p1, GSMD_VARIABLE_TYPE_LABEL, 4, _gsc_p3, _gsc_p4, _gsc_p5, _gsc_p6 : return
	if _gsc_p2 == 2 : gs_variable_recreateid _gsc_p1, GSMD_VARIABLE_TYPE_STR, 16, _gsc_p3, _gsc_p4, _gsc_p5, _gsc_p6 : return
	if _gsc_p2 == 3 : gs_variable_recreateid _gsc_p1, GSMD_VARIABLE_TYPE_DOUBLE, 8, _gsc_p3, _gsc_p4, _gsc_p5, _gsc_p6 : return
	if _gsc_p2 == 4 : gs_variable_recreateid _gsc_p1, GSMD_VARIABLE_TYPE_INT, 4, _gsc_p3, _gsc_p4, _gsc_p5, _gsc_p6 : return
	gsc_error -1, "dimtype: unknown type. p2="+_gsc_p2
	return

*GS_END
	gsc_thread_delete _gsc_thread
	_gsc_break = 1
	return

*GS_WAIT
	_gsc_break = 1
	_gsc_wait = _gsc_p1-1
	if _gsc_wait < 0 : _gsc_wait = 0
	return

*GS_WAITFOR
	if _gsc_p1 == 0 {
		//	false
		_gsc_break = 1
		_gsc_wait = _gsc_p2
		if _gsc_wait < 0 : _gsc_wait = 0
		;_gsc_addr -= (_gsc_funcsize+5)	//	1+2+2+funcsize = f(1), func_index(2), psize(2), funcsize
		_gsc_addr = _gsc_op_head
	}
	return

*GS_IF
	if _gsc_p1 == 0 {
		//	false
		_gsc_addr = lpeek(_gsc_code_bin,_gsc_addr)
		;_gsc_addr += 4
	} else {
		_gsc_addr += 4
	}
	return

*GS_ELSE
	_gsc_addr = lpeek(_gsc_code_bin,_gsc_addr)
	;_gsc_addr += 4
	return

//	repeat loop break continue ̋ł邾HSPɋߕtj
*GS_REPEAT
	//	ǉ̈	4byte	XNvgő΂ƂȂĂloop̎AhX
	_gsc_addr += 4

	if _gsc_i1 == 0 : _gsc_p1 = -1
	if _gsc_p1 == 0 {
		_gsc_addr = lpeek(_gsc_code_bin,_gsc_addr-4)
		return
	}
	gsc_stack_push : if _gsc_error : return
	_gsc_cur_stack_type		= GSMD_CORE_STACK_TYPE_REPEAT
	_gsc_cur_stack_code		= _gsc_code_ID
	_gsc_cur_stack_addr		= _gsc_addr		//	repeat ̎̃AhX
	_gsc_cur_stack_max		= _gsc_p1 + _gsc_p2
	_gsc_cur_stack_cnt		= _gsc_p2
	_gsc_sv_cnt = _gsc_cur_stack_cnt
	return

*GS_LOOP
	if _gsc_stack_index == 0 {	//	X^bNɉȂԂŎsꂽꍇ
		gsc_error -1, "loop: called in stack 0."
		return
	}
	if _gsc_cur_stack_type != GSMD_CORE_STACK_TYPE_REPEAT {	//	stack_type  repeat ł͂Ȃꍇ
		gsc_error -1, "loop: stack type mismatched."
		return
	}

	_gsc_cur_stack_cnt++
	if (_gsc_cur_stack_cnt < _gsc_cur_stack_max) || (_gsc_cur_stack_max < 0) {
		if _gsc_code_ID != _gsc_cur_stack_code {
			_gsc_code_ID = _gsc_cur_stack_code
			gs_code_dup _gsc_code_ID, _gsc_code_bin, _gsc_code_size
		}
		_gsc_addr = _gsc_cur_stack_addr		//	X^bNɕێĂAhXɖ߂
		_gsc_sv_cnt = _gsc_cur_stack_cnt
		return
	}

	gsc_stack_pop
	if _gsc_cur_stack_type == GSMD_CORE_STACK_TYPE_REPEAT {
		_gsc_sv_cnt = _gsc_cur_stack_cnt
	} else {
		repeat -1, 1
			if (_gsc_stack_index-cnt) <= 0 : _gsc_sv_cnt = 0 : break
			if _gsc_stack_type(_gsc_stack_index-cnt) == GSMD_CORE_STACK_TYPE_REPEAT : _gsc_sv_cnt = _gsc_stack_cnt(_gsc_stack_index-cnt) : break
		loop
	}
	return

*GS_BREAK
	//	ǉ̈	4byte	Orepeat̒ǉ̈AhX
	//	QƌɃWv̂ _gsc_addr+=4 ͂Ȃ

	if _gsc_stack_index == 0 {	//	X^bNɉȂԂŎsꂽꍇ
		gsc_error -1, "break: called in stack 0."
		return
	}
	if _gsc_cur_stack_type != GSMD_CORE_STACK_TYPE_REPEAT {	//	stack_type  repeat ł͂Ȃꍇ
		gsc_error -1, "break: stack type mismatched."
		return
	}
	_gsc_addr = lpeek(_gsc_code_bin,lpeek(_gsc_code_bin,_gsc_addr))
	gsc_stack_pop
	if _gsc_cur_stack_type == GSMD_CORE_STACK_TYPE_REPEAT {
		;gs_variable_write_int _gsc_sv_cnt, _gsc_cur_stack_cnt
		_gsc_sv_cnt = _gsc_cur_stack_cnt
	} else {
		repeat -1, 1
			if (_gsc_stack_index-cnt) <= 0 : _gsc_sv_cnt = 0 : break
			if _gsc_stack_type(_gsc_stack_index-cnt) == GSMD_CORE_STACK_TYPE_REPEAT : _gsc_sv_cnt = _gsc_stack_cnt(_gsc_stack_index-cnt) : break
		loop
	}
	return

*GS_CONTINUE
	//	ǉ̈	4byte	Orepeat̎AhX
	//	QƌɃWv̂ _gsc_addr+=4 ͂Ȃ

	if _gsc_stack_index == 0 {	//	X^bNɉȂԂŎsꂽꍇ
		gsc_error -1, "continue: called in stack 0."
		return
	}
	if _gsc_cur_stack_type != GSMD_CORE_STACK_TYPE_REPEAT {	//	stack_type  repeat ł͂Ȃꍇ
		gsc_error -1, "continue: stack type mismatched."
		return
	}

	if _gsc_i1 != 0 {	//	t
		_gsc_cur_stack_cnt = _gsc_p1
	} else {
		_gsc_cur_stack_cnt++
	}
	if (_gsc_cur_stack_cnt < _gsc_cur_stack_max) || (_gsc_cur_stack_max < 0) {
		if _gsc_code_ID != _gsc_cur_stack_code {
			_gsc_code_ID = _gsc_cur_stack_code
			gs_code_dup _gsc_code_ID, _gsc_code_bin, _gsc_code_size
		}
		_gsc_addr = _gsc_cur_stack_addr
		_gsc_sv_cnt = _gsc_cur_stack_cnt
		return
	}

	//	[v񐔂̂Ŕ
	_gsc_addr = lpeek(_gsc_code_bin,lpeek(_gsc_code_bin,_gsc_addr))
	gsc_stack_pop
	if _gsc_cur_stack_type == GSMD_CORE_STACK_TYPE_REPEAT {
		_gsc_sv_cnt = _gsc_cur_stack_cnt
	} else {
		repeat -1, 1
			if (_gsc_stack_index-cnt) <= 0 : _gsc_sv_cnt = 0 : break
			if _gsc_stack_type(_gsc_stack_index-cnt) == GSMD_CORE_STACK_TYPE_REPEAT : _gsc_sv_cnt = _gsc_stack_cnt(_gsc_stack_index-cnt) : break
		loop
	}
	return

*GS_GOTO
	if _gsc_code_ID != gs_label_get_code(_gsc_p1) {
		_gsc_code_ID = gs_label_get_code(_gsc_p1)
		gs_code_dup _gsc_code_ID, _gsc_code_bin, _gsc_code_size
	}
	_gsc_addr = gs_label_get_address(_gsc_p1)
	return

*GS_GOSUB
	gsc_stack_push : if _gsc_error : return
	_gsc_cur_stack_type = GSMD_CORE_STACK_TYPE_GOSUB
	_gsc_cur_stack_code = _gsc_code_ID
	_gsc_cur_stack_addr = _gsc_addr
	;_gsc_cur_stack_max = 0
	;_gsc_cur_stack_cnt = 0

	if _gsc_code_ID != gs_label_get_code(_gsc_p1) {
		_gsc_code_ID = gs_label_get_code(_gsc_p1)
		gs_code_dup _gsc_code_ID, _gsc_code_bin, _gsc_code_size
	}
	_gsc_addr = gs_label_get_address(_gsc_p1)
	return

*GS_EXGOTO
	//	ǉ̈	1byte	Ԗ̃TCY
	//				nbyte	Ԗ
	memcpy str_temp, _gsc_code_bin, peek(_gsc_code_bin,_gsc_addr), 0, _gsc_addr+1
	poke str_temp, peek(_gsc_code_bin,_gsc_addr), 0
	_gsc_addr += peek(_gsc_code_bin,_gsc_addr)+1

	p = instr(_gsc_p1,0,"@")		//	@ 邩ׂ
	if p != -1 {						//	@ 
		if (strlen(_gsc_p1)-1) == p {	//	abc@ ̂悤ɈԌɂĂ
			poke _gsc_p1, p, 0		//	@ 
		}
	} else {						//	@ Ȃ
		_gsc_p1 += "@"+str_temp		//	@+ns_string
	}

	p = gs_label_search(_gsc_p1)
	if p == -1 {
		gsc_error -1, "goto: label '"+_gsc_p1+"' is not found."
		return
	}
	s = gs_label_get_code(p)
	if _gsc_code_ID != s {
		_gsc_code_ID = s
		gs_code_dup _gsc_code_ID, _gsc_code_bin, _gsc_code_size
	}
	_gsc_addr = gs_label_get_address(p)
	return

*GS_EXGOSUB
	//	ǉ̈	1byte	Ԗ̃TCY
	//				nbyte	Ԗ
	memcpy str_temp, _gsc_code_bin, peek(_gsc_code_bin,_gsc_addr), 0, _gsc_addr+1
	poke str_temp, peek(_gsc_code_bin,_gsc_addr), 0
	_gsc_addr += peek(_gsc_code_bin,_gsc_addr)+1

	p = instr(_gsc_p1,0,"@")		//	@ 邩ׂ
	if p != -1 {						//	@ 
		if (strlen(_gsc_p1)-1) == p {	//	abc@ ̂悤ɈԌɂĂ
			poke _gsc_p1, p, 0		//	@ 
		}
	} else {						//	@ Ȃ
		_gsc_p1 += "@"+str_temp		//	@+ns_string
	}

	p = gs_label_search(_gsc_p1)
	if p == -1 {
		gsc_error -1, "gosub: label '"+_gsc_p1+"' is not found."
		return
	}

	gsc_stack_push : if _gsc_error : return
	_gsc_cur_stack_type = GSMD_CORE_STACK_TYPE_GOSUB
	_gsc_cur_stack_code = _gsc_code_ID
	_gsc_cur_stack_addr = _gsc_addr
	;_gsc_cur_stack_max = 0
	;_gsc_cur_stack_cnt = 0

	s = gs_label_get_code(p)
	if _gsc_code_ID != s {
		_gsc_code_ID = s
		gs_code_dup _gsc_code_ID, _gsc_code_bin, _gsc_code_size
	}
	_gsc_addr = gs_label_get_address(p)
	return

*GS_RETURN
	if _gsc_stack_index == 0 {	//	X^bNɉȂԂŎsꂽꍇ
		if _gsc_run_thread_id > 0 {	//	sXbhw̏ꍇ return ŏIł悤ɂ
			if _gsc_i1 {	//	L
				_gsc_run_thread_return = _gsc_p1
			} else {
				_gsc_run_thread_return = 0
			}
			_gsc_break = 1
			return
		}
		gsc_error -1, "return: stack level is 0."
		return
	}
	if _gsc_cur_stack_type != GSMD_CORE_STACK_TYPE_GOSUB {	//	stack_type  gosub ł͂Ȃꍇ
		gsc_error -1, "return: stack type mismatched."
		return
	}

	if _gsc_code_ID != _gsc_cur_stack_code {
		_gsc_code_ID = _gsc_cur_stack_code
		gs_code_dup _gsc_code_ID, _gsc_code_bin, _gsc_code_size
	}
	_gsc_addr = _gsc_cur_stack_addr
	gsc_stack_pop

	if _gsc_i1 {	//	L
		if (vartype(_gsc_p1) == 4) : _gsc_sv_stat = _gsc_p1 : return
		if (vartype(_gsc_p1) == 3) : _gsc_sv_refdval = _gsc_p1 : return
		if (vartype(_gsc_p1) == 2) : _gsc_sv_refstr = _gsc_p1 : return
	}
	return

*GS_CREATETHREAD
	_gsc_sv_stat = gsc_thread_create()
	gs_thread_set_labelid _gsc_sv_stat, _gsc_p1
	if stat == -1 : _gsc_sv_stat = -1
	return

*GS_DELETETHREAD
	if _gsc_p1 == -1 : _gsc_p1 = _gsc_thread
	if _gsc_p1 == _gsc_thread {
		_gsc_break = 1
	}
	gs_thread_delete _gsc_p1
	if stat == -1 : _gsc_sv_stat = -1 : else : _gsc_sv_stat = 0
	return

#global

gs_sysdef_init

#endif